<?php

namespace Feedbii\DataCollector;


/**
 * Class Catalog
 * @package Feedbii\DataCollector
 */
class Catalog extends AbstractDataCollector implements DataCollectorInterface
{

    /**
     * @return array
     */
    public function getProducts()
    {

        $sql = "SELECT p.produit_id";
        $sql.=", pn.produit_nom_nom";
        $sql.=", m.marque_id";
        $sql.=", m.marque_nom";
        $sql.=", GROUP_CONCAT(pc.categorie_id) as liste_categorie";
        $sql.=" FROM (produit p)";
        $sql.=" LEFT JOIN produit_nom pn ON (p.produit_id = pn.produit_id AND langue_id = 1)";
        $sql.=" LEFT JOIN produit_categorie pc ON (pc.produit_id = p.produit_id)";
        $sql.=" LEFT JOIN marque m ON (p.marque_id = m.marque_id)";
        $sql.=" WHERE 1";
        $sql.=' GROUP BY p.produit_id';

        $this->db->getAll($sql);
        $result2 = $this->db->record;

        $arrProduit = array();

        $sql = "SELECT *,c.categorie_id";
        $sql.=" FROM categorie c";
        $sql.=" LEFT JOIN categorie_nom cn ON (c.categorie_id = cn.categorie_id AND langue_id = 1)";
        $sql.=" ORDER BY c.parent_id, c.categorie_id";
        $this->db->getAll($sql);
        $categories = $this->db->record;

        $indexedCategories = array();
        foreach ($categories as $cat){
            $indexedCategories[$cat['categorie_id']] = $cat;
        }

        foreach ($indexedCategories as $key => $cat){
            if (!empty($cat['parent_id'])){
                if(!empty($indexedCategories[$cat['parent_id']]['parent_id'])){
                    $indexedCategories[$key]['grand_parent'] = $indexedCategories[$indexedCategories[$cat['parent_id']]['parent_id']];
                    $indexedCategories[$key]['grand_parent_nom'] = $indexedCategories[$key]['grand_parent']['categorie_nom_nom'];
                    $indexedCategories[$key]['grand_parent_id'] = $indexedCategories[$key]['grand_parent']['categorie_id'];
                }
                if(!empty($indexedCategories[$cat['parent_id']]))	$indexedCategories[$key]['parent'] = $indexedCategories[$cat['parent_id']];
                if(!empty($indexedCategories[$cat['parent_id']]['categorie_nom_nom']))	$indexedCategories[$key]['parent_nom'] = $indexedCategories[$cat['parent_id']]['categorie_nom_nom'];
            }
        }

        foreach($result2 as $k => $row) {
            $arrProduit[$k] = array();
            $arrProduit[$k]['produit_id'] = $row['produit_id'];
            $arrProduit[$k]['nom'] = $row['produit_nom_nom'];
            $arrProduit[$k]['url'] = $this->parseURL($row['produit_nom_nom'])."-".$row['produit_id'].".html";
            $arrProduit[$k]['categorie'] = array();

            $productCategories = explode(',',$row['liste_categorie']);

            $catNiv1 = array();
            $catNiv2 = array();
            $catNiv3 = array();

            foreach ($productCategories as $catId){
                if (array_key_exists($catId,$indexedCategories)){
                    if (!empty($indexedCategories[$catId]['grand_parent_nom']) && !empty($indexedCategories[$catId]['parent_nom'])){
                        $catNiv3[$catId] = $indexedCategories[$catId];
                        $catNiv2[$catId] = $indexedCategories[$catId]['parent'];
                        $catNiv1[$catId] = $indexedCategories[$catId]['grand_parent'];
                    }elseif (!empty($indexedCategories[$catId]['parent_nom'])){
                        $catNiv2[$catId] = $indexedCategories[$catId];
                        $catNiv1[$catId] = $indexedCategories[$catId]['parent'];
                    }else {
                        $catNiv1[$catId] = $indexedCategories[$catId];
                    }
                }
            }

            if(!empty($catNiv1)) {
                foreach($catNiv1 as $cat) {
                    $tmp = array();
                    $tmp['id'] = $cat['categorie_id'];
                    $tmp['nom'] = $cat['categorie_nom_nom'];
                    //$tmp['url'] = generateUrl("page=liste_1&categorie_nom=" . $cat['categorie_nom_nom'] . "&id=" . $cat['categorie_id']);
                    array_push($arrProduit[$k]['categorie'], $tmp);
                }
            }

            if(!empty($catNiv2)) {
                foreach($catNiv2 as $cat) {
                    if (empty($cat['parent_nom'])){
                        continue;
                    }
                    $tmp = array();
                    $tmp['id'] = $cat['categorie_id'];
                    $tmp['nom'] = $cat['categorie_nom_nom'];
                    //$tmp['url'] = generateUrl("page=liste_2&parent_nom=".$cat['parent_nom']."&categorie_nom=".$cat['categorie_nom_nom']."&id=".$cat['categorie_id']);
                    array_push($arrProduit[$k]['categorie'], $tmp);
                }
            }

            if(!empty($catNiv3)) {
                foreach($catNiv3 as $cat) {
                    $tmp = array();
                    $tmp['id'] = $cat['categorie_id'];
                    $tmp['nom'] = $cat['categorie_nom_nom'];
                    //$tmp['url'] = generateUrl("page=liste_3&grand_parent_nom=".$cat['grand_parent_nom']."&parent_nom=".$cat['parent_nom']."&categorie_nom=".$cat['categorie_nom_nom']."&id=".$cat['categorie_id']);
                    array_push($arrProduit[$k]['categorie'], $tmp);
                }
            }


            $arrProduit[$k]['marque'] = array();

            $arrMarque = array();
            $arrMarque[$row['marque_id']] = array();
            $arrMarque[$row['marque_id']]['id'] = $row['marque_id'];
            $arrMarque[$row['marque_id']]['nom'] = $row['marque_nom'];
            //$arrMarque[$row['marque_id']]['url'] = generateURL('page=marque&marque_nom='.parseURL($row['marque_nom']).'&marque_id='.$row['marque_id']);

            foreach ($arrMarque as $m) {
                array_push($arrProduit[$k]['marque'],$m);
            }
        }
        return $arrProduit;
    }

    /**
     * @return array
     */
    public function getCategories()
    {

        $sql = 'SELECT';
        $sql .= ' c.categorie_id';
        $sql .= ' FROM (categorie c)';
        $sql .= ' WHERE c.parent_id IS NULL';
        $sql .= ' GROUP BY c.categorie_id';

        $this->db->query($sql, SQL_ALL, SQL_ASSOC);
        $result = $this->db->record;

        if (!$result) {
            echo mysqli_error($this->db) . "<br/>";
        }

        $key          = 0;
        $arrCategorie = array();
        foreach ($result as $k => $row) {
            $sql = "SELECT cn.categorie_id";
            $sql .= ", cn.categorie_nom_nom";
            $sql .= " FROM (categorie_nom cn)";
            $sql .= " WHERE cn.langue_id = 1 AND cn.categorie_id = " . $row['categorie_id'];

            $this->db->query($sql, SQL_INIT, SQL_ASSOC);
            $superparent = $this->db->record;

            $arrCategorie[$key]                     = array();
            $arrCategorie[$key]['categorie_id']     = $superparent['categorie_id'];
            $arrCategorie[$key]['categorie']        = $superparent['categorie_nom_nom'];
            $arrCategorie[$key]['parent_id']        = '';
            $arrCategorie[$key]['parent']           = '';
            $arrCategorie[$key]['niv_categorie'] = '1';
            $arrCategorie[$key]['url']              = generateURL("page=liste_1&categorie_nom=" . $superparent['categorie_nom_nom'] . "&id=" . $superparent['categorie_id']);

            $key++;

            $sql = 'SELECT';
            $sql .= ' c.categorie_id';
            $sql .= ' FROM (categorie c)';
            $sql .= ' WHERE c.parent_id = ' . $superparent['categorie_id'];
            $sql .= ' GROUP BY c.categorie_id';

            $this->db->query($sql, SQL_ALL, SQL_ASSOC);
            $result2 = $this->db->record;
            foreach ($result2 as $k2 => $row2) {
                $sql = "SELECT cn.categorie_id";
                $sql .= ", cn.categorie_nom_nom";
                $sql .= " FROM (categorie_nom cn)";
                $sql .= " WHERE cn.langue_id = 1 AND cn.categorie_id = " . $row2['categorie_id'];

                $this->db->query($sql, SQL_INIT, SQL_ASSOC);
                $parent = $this->db->record;

                $arrCategorie[$key]                     = array();
                $arrCategorie[$key]['categorie_id']     = $parent['categorie_id'];
                $arrCategorie[$key]['categorie']        = $parent['categorie_nom_nom'];
                $arrCategorie[$key]['parent_id']        = $superparent['categorie_id'];
                $arrCategorie[$key]['parent']           = $superparent['categorie_nom_nom'];
                $arrCategorie[$key]['niv_categorie'] = '2';
                $arrCategorie[$key]['url']              = generateURL("page=liste_2&parent_nom=" . $superparent['categorie_nom_nom'] . "&categorie_nom=" . $parent['categorie_nom_nom'] . "&id=" . $parent['categorie_id']);

                $key++;

                $sql = 'SELECT';
                $sql .= ' c.categorie_id';
                $sql .= ' FROM (categorie c)';
                $sql .= ' WHERE c.parent_id = ' . $superparent['categorie_id'];
                $sql .= ' GROUP BY c.categorie_id';

                $this->db->query($sql, SQL_ALL, SQL_ASSOC);
                $result3 = $this->db->record;
                foreach ($result3 as $k3 => $row3) {
                    $sql = "SELECT cn.categorie_id";
                    $sql .= ", cn.categorie_nom_nom";
                    $sql .= " FROM (categorie_nom cn)";
                    $sql .= " WHERE cn.langue_id = 1 AND cn.categorie_id = " . $row3['categorie_id'];

                    $this->db->query($sql, SQL_INIT, SQL_ASSOC);
                    $cat = $this->db->record;

                    $arrCategorie[$key]                     = array();
                    $arrCategorie[$key]['categorie_id']     = $cat['categorie_id'];
                    $arrCategorie[$key]['categorie']        = $cat['categorie_nom_nom'];
                    $arrCategorie[$key]['parent_id']        = $parent['categorie_id'];
                    $arrCategorie[$key]['parent']           = $parent['categorie_nom_nom'];
                    $arrCategorie[$key]['niv_categorie'] = '3';
                    $arrCategorie[$key]['url']              = generateURL("page=liste_3&grand_parent_nom=" . $superparent['categorie_nom_nom'] . "&parent_nom=" . $parent['categorie_nom_nom'] . "&categorie_nom=" . $cat['categorie_nom_nom'] . "&id=" . $cat['categorie_id']);

                    $key++;

                }
            }
        }
        return $arrCategorie;
    }

    /**
     * @return array
     */
    public function getMarques()
    {
        $sql='SELECT';
        $sql.=' m.marque_id';
        $sql.=' FROM (marque m)';
        $sql.=' WHERE 1';
        $sql.=' GROUP BY m.marque_id';

        $this->db->query($sql, SQL_ALL, SQL_ASSOC);
        $result = $this->db->record;

        if (!$result){
            echo mysqli_error($this->db)."<br/>";
        }

        $arrMarque = array();
        foreach($result as $k => $row) {
            $sql = "SELECT m.marque_id";
            $sql.=", m.marque_nom";

            $sql.=" FROM (marque m)";

            $sql.=" WHERE m.marque_id = ".$row['marque_id'];

            $this->db->query($sql, SQL_INIT, SQL_ASSOC);
            $result2 = $this->db->record;

            $arrMarque[$k] = array();
            $arrMarque[$k]['marque_id'] = $result2['marque_id'];
            $arrMarque[$k]['marque_nom'] = $result2['marque_nom'];
            $arrMarque[$k]['url'] = generateURL('page=marque&marque_nom='.parseURL($result2['marque_nom']).'&marque_id='.$result2['marque_id']);

        }

        return $arrMarque;
    }

    /**
     * Parsage url
     */
    function parseURL($text) {


        $text = trim(mb_strtolower($text));

        $table = array(
            'Š' => 'S', 'š' => 's', 'Đ' => 'D', 'đ' => 'd', 'Ž' => 'Z', 'ž' => 'z', 'Č' => 'C', 'č' => 'c', 'Ć' => 'C', 'ć' => 'c',
            'À' => 'A', 'Á' => 'A', 'Â' => 'A', 'Ã' => 'A', 'Ä' => 'A', 'Å' => 'A', 'Æ' => 'A', 'Ç' => 'C', 'È' => 'E', 'É' => 'E',
            'Ê' => 'E', 'Ë' => 'E', 'Ì' => 'I', 'Í' => 'I', 'Î' => 'I', 'Ï' => 'I', 'Ñ' => 'N', 'Ò' => 'O', 'Ó' => 'O', 'Ô' => 'O',
            'Õ' => 'O', 'Ö' => 'O', 'Ø' => 'O', 'Ù' => 'U', 'Ú' => 'U', 'Û' => 'U', 'Ü' => 'U', 'Ý' => 'Y', 'Þ' => 'B', 'ß' => 'Ss',
            'à' => 'a', 'á' => 'a', 'â' => 'a', 'ã' => 'a', 'ä' => 'a', 'å' => 'a', 'æ' => 'a', 'ç' => 'c', 'è' => 'e', 'é' => 'e',
            'ê' => 'e', 'ë' => 'e', 'ì' => 'i', 'í' => 'i', 'î' => 'i', 'ï' => 'i', 'ð' => 'o', 'ñ' => 'n', 'ò' => 'o', 'ó' => 'o',
            'ô' => 'o', 'õ' => 'o', 'ö' => 'o', 'ø' => 'o', 'ù' => 'u', 'ú' => 'u', 'û' => 'u', 'ý' => 'y', 'ý' => 'y', 'þ' => 'b',
            'ÿ' => 'y', 'Ŕ' => 'R', 'ŕ' => 'r', ' - ' => '-', ' ' => '-', '&' => 'et'
        );

        $text = strtr($text, $table);

        $text = preg_replace('/[^a-z0-9-]/', '', $text);

        return $text;
    }
}